<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of AdminSegmentor
 *
 * @author ffozeu
 */
class AdminSegmentorController extends ModuleAdminController {
    
    //put your code here
    public $template = 'content.tpl';
    
    public function __construct(){        
        
        parent::__construct();
        
        /* PS 1.6 */
        $this->bootstrap = true;
        $this->ps_version  = Tools::substr(_PS_VERSION_,0,3);
        
        $this->tpl_folder = $this->getTemplatePath();
        $this->className = $this->tabAccess['class_name'];         
    }
    
    public function display()
    {
        
        $this->content = 'content';
        $this->display = $this->content;
        
		$this->context->smarty->assign(array(
				'display_header' => $this->display_header,
				'display_footer' => $this->display_footer,
				)
			);

		// Use page title from meta_title if it has been set else from the breadcrumbs array
		if (!$this->meta_title)
			$this->meta_title = isset($this->breadcrumbs[1]) ? $this->breadcrumbs[1] : $this->breadcrumbs[0];
		$this->context->smarty->assign('meta_title', $this->meta_title);

		$tpl_action = $this->tpl_folder.$this->display.'.tpl';
		// Check if action template has been override
        if (file_exists($tpl_action) && $this->display != 'view' && $this->display != 'options')
        {
            if (method_exists($this, $this->display.Tools::toCamelCase($this->className)))
                $this->{$this->display.Tools::toCamelCase($this->className)}();
        
            $this->context->smarty->assign(array('content'=> $this->context->smarty->fetch($tpl_action)));
        }

		if (!$this->ajax)
		{
			$template = $this->createTemplate($this->template);
			$page = $template->fetch();
		}
		else
			$page = $this->content;
                
                
                if($this->ps_version=='1.6'){
                    $page = '<link rel="stylesheet" type="text/css" href="'._MODULE_DIR_.'segmentor/styles_1.6.css">'.$page;
                }

		if ($conf = Tools::getValue('conf'))
			if ($this->json)
				$this->context->smarty->assign('conf', Tools::jsonEncode($this->_conf[(int)$conf]));
			else
				$this->context->smarty->assign('conf', $this->_conf[(int)$conf]);


		if ($this->json)
			$this->context->smarty->assign('errors', Tools::jsonEncode($this->errors));
		else
			$this->context->smarty->assign('errors', $this->errors);

		if ($this->json)
			$this->context->smarty->assign('warnings', Tools::jsonEncode($this->warnings));
		else
			$this->context->smarty->assign('warnings', $this->warnings);


		if ($this->json)
			$this->context->smarty->assign('informations', Tools::jsonEncode($this->informations));
		else
			$this->context->smarty->assign('informations', $this->informations);

		if ($this->json)
			$this->context->smarty->assign('confirmations', Tools::jsonEncode($this->confirmations));
		else
			$this->context->smarty->assign('confirmations', $this->confirmations);

		if ($this->json)
			$this->context->smarty->assign('page', Tools::jsonEncode($page));
		else
			$this->context->smarty->assign('page', $page);
                
                
                if($this->ps_version>='1.6'){
                    $dir = $this->context->smarty->getTemplateDir(0).'controllers'.DIRECTORY_SEPARATOR.trim($this->override_folder, '\\/').DIRECTORY_SEPARATOR;
                    $header_tpl = file_exists($dir.'header.tpl') ? $dir.'header.tpl' : 'header.tpl';
                    $footer_tpl = file_exists($dir.'footer.tpl') ? $dir.'footer.tpl' : 'footer.tpl';
                    $this->context->smarty->assign(array(
                            'header' => $this->context->smarty->fetch($header_tpl),
                            'footer' => $this->context->smarty->fetch($footer_tpl),
                            )
                    );
                }
                
		$this->smartyOutputContent($this->layout);
    }
    
    public function initContent(){
        parent::initContent();
        $obj = new Segmentor();
        $contenu = '';
        $selectcontent['supplier'] = $this->getSelectOpt('supplier');
        $selectcontent['manufacturer'] = $this->getSelectOpt('manufacturer');
        $selectcontent['group'] = $this->getSelectOpt('group');
        $selectcontent['country'] = $this->getSelectOpt('country');
		$this->context->smarty->assign(array(
            'contenu' => $contenu,
			'content' => $this->content,
            'pathmod' => $obj->_urlModDir,
            'selectcontent' => $selectcontent,
            'iso_code' => $this->context->currency->iso_code,
            'totalsresultfind' => $obj->getCostumerResearchResult(),
            'url_post' => self::$currentIndex.'&token='.$this->token,
		));
    }
    /**
     * Chragement des différentes librairies nécessaires
     */
    public function setMedia()
	{
		parent::setMedia();
        $obj = new Segmentor();
        $this->addJquery();
        $this->addjQueryPlugin(array(
            'date',
            'autocomplete'
        ));

        $this->addJqueryUI(array(
            'ui.core',
            'ui.widget',
            'ui.slider',
            'ui.datepicker'
        ));
        $this->addCSS(array(
            $obj->_urlModDir.'css/segmentor.css',
        ));
        $this->addJS(array(
            $obj->_urlModDir.'js/jquery.tablesorter.js',
            $obj->_urlModDir.'js/segmentor.js',
        ));
        
	}
    
    function getSelectOpt($type){
        $out = array();
        switch ($type) {
            case 'supplier':
                $result = Supplier::getSuppliers();
                $out = $this->generateSelect($result,'id_supplier','name');                
                break;
            case 'manufacturer':
                $result = Manufacturer::getManufacturers();
                $out = $this->generateSelect($result,'id_manufacturer','name');                
                break;
            case 'group':
                $result = Group::getGroups($this->context->cookie->id_lang,$this->context->cookie->id_shop);
                $out = $this->generateSelect($result,'id_group','name');                
                break;
            case 'country':
                $result = Country::getCountries($this->context->cookie->id_lang,true);
                $out = $this->generateSelect($result,'id_country','name');                
                break;
            default:
                break;
        }
        return $out;
    }
    private function generateSelect($result, $key1,$key2){
        $out = array();$out2 = array();
        if(is_array($result) && sizeof($result)){
            foreach ($result as $value){
               $out2['id']= $value[$key1];
               $out2['name'] = $value[$key2];
               $out[]=$out2;
            }
        }
        return $out;
    }
    
    public function ajaxProcess(){
       $obj = new Segmentor();
        $paramsearch = Tools::getValue('paramsearch');
        if($paramsearch){
            $limit = Tools::getValue('limit');
            $aResults = '';
            $limit = ($limit!='' ? $limit : 0);
            $q = Tools::getValue('q');
            $input = Tools::strtolower($q);
            $param = Tools::strlen($input);
            switch ($paramsearch){
                case 'name':
                    $aUsers = $obj->getProductList('name', $input, $limit);
                    break;
                default:
                    break;
            }
            if ($param)
            {
                $aResults .= '';
                foreach($aUsers as $key => $value)
                { 
                    $aResults .= trim($value['name']).'|'.(int)($value['id_product'])."\n";
                }
            }
            die($aResults);		
        }
    }
    public function ajaxProcessFilterSearch(){
        $current = AdminTab::$currentIndex;
        $obj = new Segmentor();
        $this->context->smarty->assign(array(
            'totalsresultfind' => $obj->getCostumerResearchResult(),
            'url_post' => $current.'&token='.Tools::getValue('token'),
            'pathmod' => $obj->_urlModDir,
        ));
        $this->smartyOutputContent($this->getTemplatePath().'searchresult.tpl');
        exit();
    }
    public function ajaxProcessExportCSV(){
        $current = AdminTab::$currentIndex;
        $obj = new Segmentor();
        $fichier = $obj->generateCSVExport($_POST);
        echo $fichier;
        $this->context->smarty->assign(array());
        exit();
    }
    
    public function ajaxProcessTransfertGroup(){
        $current = AdminTab::$currentIndex;
        $this->context->smarty->assign(array());
        $objs = new Segmentor();
        if(Tools::getValue('move_add_group') == 1)
            $objs->addCustumersgroup ();
        else
            $objs->DeleteCustumersgroup ();
        
        $this->context->smarty->assign(array(
            'totalsresultfind' => $objs->getCostumerResearchResult(),
            'url_post' => $current.'&token='.Tools::getValue('token'),
            'pathmod' => $objs->_urlModDir,
        ));
        $this->smartyOutputContent($this->getTemplatePath().'searchresult.tpl');
        exit();
    }
}

?>
