<?php

/*
 * Réalisé par Webbax
 * http://www.webbax.ch
 * contact@webbax.ch
 * 
 * Export de clients ciblés + segmentation via des groupes
 * 
 */

/* 
 Correctifs
 V1.6.3 - 29.06.15
 - correction sur deux requêtes par groupes clients
 V1.6.2 - 23.04.15
 - correction sur filtre par montant "total" cumulé
 V1.6.1 - 23.02.15
 - ajout message erreur installation en cas d'échec (varad.txt)
 V1.6.0 - 11.10.14
 - compatibilité Prestashop 1.6
 */

if (!defined('_PS_VERSION_'))
    exit;

class Segmentor extends Module{
    //put your code here
    
    //put your code here
    public $_urlModDir = "";
    public $_pathModDir = "";
    private $_html = '';
    public $ajaxPatch ='';

    function __construct() {

        $this->name = 'segmentor';
        $this->author = 'Webbax';
        $this->tab = 'administration';
        $this->version = '1.6.3';
        $this->siteauthor = 'http://www.webbax.ch';  
        $this->module_key = 'd2cb9bfee45019a33e9d9661eff60dcd';
        
        /* PS 1.6 */
        $this->bootstrap = true;
        $this->ps_version  = Tools::substr(_PS_VERSION_,0,3);

        /* The parent construct is required for translations */
        parent::__construct();
        
        $this->_urlModDir = _MODULE_DIR_ . $this->name . '/';
        $this->ajaxPatch = $this->_path.'ajax-segmentor.php';
        $this->displayName = $this->l('segmentor');  
        $this->description = $this->l('Segment, sort your customers and advertise');
        $this->description .= '<br/><span style="font-weight:bold;">'.$this->l('Module produced by').'&nbsp;<a href="http://www.webbax.ch/" class="action_module" target="_blank">'.$this->l('www.webbax.ch').'</span></a>';
        
    }
    
    public function install() {
        $data = "<?php $pathAdmin = '"._PS_ADMIN_DIR_."'; ?>";
		$file = dirname(__FILE__).'/varad.txt';
        if(!file_put_contents($file,_PS_ADMIN_DIR_)){
			$this->context->controller->errors[] = $this->l('Impossible de créer le fichier').' : '.dirname(__FILE__).' ('.$this->l('modifiez le CHMOD sur ce répertoire').')';
			return false;
		}
        if (
			!parent::install()
			OR !$this->installModuleTab('AdminSegmentor', array(1 => 'Segmentor', 2 => 'Segmentor', 3 => 'Segmentor', 4 => 'Segmentor', 5 => 'Segmentor'), 'AdminParentCustomer')
				
        )
            return false;
        return true;
    }

    public function uninstall() {
        if (
			!parent::uninstall()
			OR !$this->uninstallModuleTab('AdminSegmentor')
        )
            return false;
        return true;
    }
    /**
     * Ajout d'un controller en BO dans l'onglets clients
     * @param type $tabClass
     * @param type $tabName
     * @param type $parentName
     * @return boolean
     */
    private function installModuleTab($tabClass, $tabName, $parentName) {
        $idTab = Tab::getIdFromClassName($parentName);
        if ($idTab != 0) {
            $tab = new Tab();
            $tab->name = $tabName;
            $tab->class_name = $tabClass;
            $tab->module = $this->name;
            $tab->id_parent = $idTab;
            if (!$tab->save())
                return false;
        }
        return true;
    }
    
    /**
     * suppression du controllers du BO
     * @param type $tabClass
     * @return boolean
     */
    private function uninstallModuleTab($tabClass) {
        $idTab = Tab::getIdFromClassName($tabClass);
        if ($idTab != 0) {
            $tab = new Tab($idTab);
            $tab->delete();
            return true;
        }
        return false;
    }
    
    public function getContent() {
        
            if($this->ps_version=='1.6'){
               $this->_html .= '<link rel="stylesheet" type="text/css" href="'.$this->_path.'styles_1.6.css">';
            }
        
            $this->_html .= '
                <div id="wrap-content" style="margin: auto; width: 56%;">
                <center><h2>' . $this->displayName . '</h2></center>';
            $this->_html .='
                <div class="warn">'.$this->l('to use this module, go to customers onglet > segmentor').'</div>
                </div>';
            return $this->_html;
    }
    /**
     * retourne la liste des produits depuis la requete AJAX ou JSON
     * @param type $seachBy
     * @param type $param
     * @param type $limit
     * @param type $active
     * @return type 
     */
    public function getProductList($seachBy = "name", $param = '', $limit = 0, $active = 1) {
        $id_lang = $this->context->cookie->id_lang;
        $id_shop = $this->context->shop->id;
        $sql = '
        SELECT p.*,pl.`name`
		FROM `' . _DB_PREFIX_ . 'product` p
		LEFT JOIN `' . _DB_PREFIX_ . 'product_lang` pl ON (p.`id_product` = pl.`id_product` AND pl.`id_lang` = '.(int)$id_lang.')
        INNER JOIN `' . _DB_PREFIX_ . 'product_shop` ps ON (ps.`id_product`=p.`id_product` AND ps.`id_shop`='.(int)$id_shop.')
		WHERE ' . ($seachBy == 'name' ? 'pl.`name` ' : 'p.`' . $seachBy . '` ') . 'LIKE "' . $param . '%" AND p.`active` = ' . (int) ($active) . '
                AND ps.`id_shop`="'.pSQL($id_shop).'" 
                AND pl.`id_shop`="'.pSQL($id_shop).'"
        LIMIT ' . (int) $limit;
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($sql);
        return $result;
    }
    /**
     * general filter
     * @return type
     */
    public function getCostumerResearchResult(){
        $id_lang = $this->context->cookie->id_lang;
        $out = array();
        $where = array();
        
        // Gestion des jointures liées au client
        $sql_join ='';
        
        // gestion du critère civilité
        if(Tools::getValue('civilty')){
            $where[] =  'c.`id_gender`IN ('.Tools::getValue('civilty').')';
        }
        
        //gestion du critère code postal
        if(Tools::getValue('codepostal')!="")
            $where[] =  'adr.`postcode` LIKE "%'.Tools::getValue('codepostal').'%"';
        
        //gestion du critère pays
        if(Tools::getValue('country')!="")
            $where[] =  'ctrylang.`id_country`='.(int)Tools::getValue('country');
        
        //gestion du critère tranche d'âge
        $age[] = (int) Tools::getValue('year1');
        $age[] = (int) Tools::getValue('year2');
        $temps1 = time() - min($age)*365*24*3600;
        $temps2 = time() - max($age)*365*24*3600;
        $dayofbirth1 = date("Y-m-d", $temps1);
        $dayofbirth2 = date("Y-m-d", $temps2);
        
        if(Tools::getValue('year1')!="" && Tools::getValue('year2')!="")			
			$where[] =  'c.`birthday` BETWEEN "'.$dayofbirth2.'" AND "'.$dayofbirth1.'"';
        elseif(Tools::getValue('year1')!="" && Tools::getValue('year2')=="")
            $where[] = 'c.`birthday`<="'.$dayofbirth1.'"';
        elseif(Tools::getValue('year1')=="" && Tools::getValue('year2')!="")
            $where[] = 'c.`birthday`>="'.$dayofbirth2.'"';
        
        //gestion du critère groupe du client
        if(Tools::getValue('customergroup') !="")
            $where[] =  'cg.`id_group`='.Tools::getValue('customergroup');
        
        // gestion du critère newsletter
         if(Tools::getValue('subscrbitenewsletter'))
            $where[] =  'c.`newsletter`='.Tools::getValue('subscrbitenewsletter');
         
         //gestion du critère publicité
         if(Tools::getValue('acceptadvert'))
            $where[] =  'c.`optin`='.Tools::getValue('acceptadvert');
         
         // gestion des critères liés au commandes 
         if(
			(Tools::getValue('haveplacedanorder') != "") OR (Tools::getValue('withdiscoutvoucher') != "") 
			OR (Tools::getValue('withnonvalidatedcart') != "") OR (Tools::getValue('orderdate1') != "")
			OR (Tools::getValue('orderdate2') != "") OR (Tools::getValue('amountorder1') != "")
			OR (Tools::getValue('amountorder2') != "")  OR (Tools::getValue('manufacturer') != "")
			OR (Tools::getValue('supplier') != "")  OR (Tools::getValue('id_product') != "") OR (Tools::getValue('productname') != "")
		){
             //jointure sur les commandes
			$sql_join_order = '';
			$sql_join_order .= ' LEFT JOIN  `' . _DB_PREFIX_ . 'orders` o ON ( o.`id_customer`= c.`id_customer`)';
			$sql_join_order .= ' LEFT JOIN  `' . _DB_PREFIX_ . 'order_detail` od ON ( od.`id_order`= o.`id_order`)';

            //gestion du critère commande
			if(Tools::getValue('haveplacedanorder') != ""){
				if(Tools::getValue('haveplacedanorder') == 1){
					$ordercryteria[] = 'c.`id_customer` IN (SELECT DISTINCT id_customer FROM `'. _DB_PREFIX_ . 'orders`)';
				}else{
					$ordercryteria[] = 'c.`id_customer` NOT IN (SELECT DISTINCT id_customer FROM `'. _DB_PREFIX_ . 'orders`)';
				}
			}            
            
            if(Tools::getValue('orderdate1')!="" && Tools::getValue('orderdate2')!="")			
                $ordercryteria[] =  'o.`date_add` BETWEEN "'.Tools::getValue('orderdate1').' '.date('H:i:s').'" AND "'.Tools::getValue('orderdate2').' '.date('H:i:s').'"';
            elseif(Tools::getValue('orderdate1')!="" && Tools::getValue('orderdate2')=="")
                $ordercryteria[] = 'o.`date_add`>="'.Tools::getValue('orderdate1').' '.date('H:i:s').'"';
            elseif(Tools::getValue('orderdate1')=="" && Tools::getValue('orderdate2')!="")
                $ordercryteria[] = 'o.`date_add`<="'.Tools::getValue('orderdate2').' '.date('H:i:s').'"';

            //gestion du critère bon de commande
			if(Tools::getValue('withdiscoutvoucher') != ""){
				if(Tools::getValue('withdiscoutvoucher') == 1)
					$ordercryteria[] = 'c.`id_customer` IN (SELECT DISTINCT car.`id_customer` FROM `'. _DB_PREFIX_ . 'cart` ca , `'. _DB_PREFIX_ . 'cart_rule` car, `'. _DB_PREFIX_ . 'cart_cart_rule` cca  WHERE cca.`id_cart_rule`=car.`id_cart_rule` AND cca.`id_cart`=ca.`id_cart`)';
				else
				$ordercryteria[] = 'c.`id_customer` NOT IN (SELECT DISTINCT car.`id_customer` FROM `'. _DB_PREFIX_ . 'cart` ca , `'. _DB_PREFIX_ . 'cart_rule` car, `'. _DB_PREFIX_ . 'cart_cart_rule` cca  WHERE cca.`id_cart_rule`=car.`id_cart_rule` AND cca.`id_cart`=ca.`id_cart`)';
			}
            
            //gestion du critère panier
            if(Tools::getValue('withnonvalidatedcart') != "")
                if(Tools::getValue('withnonvalidatedcart') == 1)
                    $ordercryteria[] = 'c.`id_customer` IN (SELECT DISTINCT id_customer FROM `'. _DB_PREFIX_ . 'cart` WHERE id_cart NOT IN (SELECT id_cart FROM `'. _DB_PREFIX_ . 'orders`))';
                else
                    $ordercryteria[] = 1;     
            
            //jointure sur les produits
            if(Tools::getValue('manufacturer') != "" OR Tools::getValue('supplier') != "" OR Tools::getValue('idProduct') != ""){
                $sql_join_order .= ' LEFT JOIN  `' . _DB_PREFIX_ . 'product` pdt ON ( pdt.`id_product`= od.`product_id`)';
            }
            
            //gstion du critère marque du produit
            if(Tools::getValue('manufacturer') != "")
                $ordercryteria[] = 'pdt.`id_manufacturer`= '.Tools::getValue('manufacturer');

            //gestion du critère fournisseur
            if(Tools::getValue('supplier') != "")
                $ordercryteria[] = 'pdt.`id_supplier`= '.Tools::getValue('supplier');

            //gestion du critère produit
            if(Tools::getValue('idProduct') != "")
                $ordercryteria[] = 'pdt.`id_product`= '.Tools::getValue('idProduct');
            if(Tools::getValue('idProduct') == "" && Tools::getValue('productname') !='')
                $ordercryteria[] = 'od.`product_name`= "'.Tools::getValue('productname').'"';
		}
        
        //sql general
        $sql ='
            SELECT DISTINCT c.`id_customer`, c.`firstname`, c.`lastname`, c.`email`, adr.`postcode`, adr.`city`, 
                ctrylang.`name` as mycountry 
            FROM `' . _DB_PREFIX_ . 'customer` c
			LEFT JOIN  `' . _DB_PREFIX_ . 'address` adr ON ( c.`id_customer`= adr.`id_customer`)
            LEFT JOIN  `' . _DB_PREFIX_ . 'country_lang` ctrylang ON ( ctrylang.`id_country`= adr.`id_country` AND ctrylang.`id_lang` = '.$id_lang.')
            LEFT JOIN `' . _DB_PREFIX_ . 'customer_group` cg ON c.`id_customer`= cg.`id_customer`
            '.$sql_join.(isset($sql_join_order)?' '.$sql_join_order:' ').' 
            WHERE c.`id_shop`='.(int)$this->context->shop->id.' AND '.(sizeof($where)?implode(' AND ', $where).' ':' 1 ').
            (isset($sql_join_order) && !empty($ordercryteria) ?' AND '.implode(' AND ', $ordercryteria):' ');
        
        // filtre par total commandé
        $filter_by_total_orders = false;
        $amountorder1 = Tools::getValue('amountorder1');
        $amountorder2 = Tools::getValue('amountorder2');
        if($amountorder1!= "" || $amountorder2!=""){
            
            if(empty($amountorder2)){$amountorder2=999999999;}
            
            $filter_by_total_orders = true;
            $orderdate1 = Tools::getValue('orderdate1');
            $orderdate2 = Tools::getValue('orderdate2');
            if(empty($orderdate1)){$orderdate1=date('1900-01-01 00:00:00');}
            if(empty($orderdate2)){$orderdate2=date('Y-m-d H:i:s');}
            
            $oSQL='SELECT id_customer,SUM(total_paid) as totalOrders FROM `'._DB_PREFIX_.'orders`
                  WHERE `date_add` BETWEEN "'.$orderdate1.'" AND "'.$orderdate2.'" GROUP BY `id_customer`';
            $res = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($oSQL);  
            $total_orders_customer=array();
            foreach($res as $r){$total_orders_customer[$r['id_customer']]=$r['totalOrders'];} 
        }
        //--
           
        //p($sql);
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($sql);
        //d($result);
        
        if(is_array($result) && sizeof($result)){
            foreach ($result as $key => $value){   
                
                // filtre par total commandé
                $takeToExport=true;
                if($filter_by_total_orders){
                    if($total_orders_customer[$value['id_customer']]<$amountorder1 
                       || $total_orders_customer[$value['id_customer']]>$amountorder2){
                       $takeToExport=false;
                    }
                }
                
                if($takeToExport){
                    $idcustomer = $value['id_customer'];                
                    $out[$idcustomer]['group'] = $this->getGroupCustomer($idcustomer,$id_lang);
                    $out[$idcustomer]['firstname'] = $value['firstname'];
                    $out[$idcustomer]['lastname'] = $value['lastname'];
                    $out[$idcustomer]['email'] = $value['email'];
                    $out[$idcustomer]['postcode'][] = $value['postcode'];
                    $out[$idcustomer]['city'][] = $value['city'];
                    $out[$idcustomer]['mycountry'][] = $value['mycountry'];
                }
            }
        }
        return $out;
    }
    /**
     * 
     * @param type $idcustomer
     * @param type $id_lang
     * @return type
     */
    private function getGroupCustomer($idcustomer,$id_lang=1,$csv=false){
        $groupc = array();
        $sql ='SELECT gl.name FROM '._DB_PREFIX_.'group_lang AS gl 
                LEFT JOIN '._DB_PREFIX_.'customer_group AS cg ON cg.id_group=gl.id_group
                WHERE gl.id_lang='.(int)$id_lang.' AND cg.id_customer='.intval($idcustomer);
        $result = Db::getInstance()->ExecuteS($sql);
        foreach($result as $value)
            $groupc[] =$csv?$this->cleanHtml($value['name']):$value['name'];
        return $groupc;
    }
    
    /**
     * Export des clients
     * @return type
     */
    public function generateCSVExport(){
        $id_lang = $this->context->cookie->id_lang;
        $params = Tools::getValue('cbidcustomer');
        if(!$params)
            return $this->displayError($this->l('Please select minimun customer'));
        $out = array();
        $fiels = array(
            'civility' => utf8_decode($this->l('Civility')),
            'firstname' => utf8_decode($this->l('First name')),
            'lastname' => utf8_decode($this->l('Last name')),
            'address1' => $this->l('Adress 1'),
            'address2' => $this->l('Adress 2'),
            'postcode' => $this->l('Post code'),
            'city' => $this->l('City'),
            'mycountry' => $this->l('Country'),
            'email' => $this->l('Email'),
            'mygroup' => $this->l('Customer group'),
            'birthday' => $this->l('Birthday'),
            'newsletter' => $this->l('Newsletter'),
            'optin' => $this->l('Opt-in'),
            'quantity_order' => utf8_decode($this->l('Order quantity')),
            'total_order' => utf8_decode($this->l('Order Amount')),
        );        
        $sql = '
            SELECT DISTINCT c.`id_customer`, cvl.name as civility, c.`firstname`, c.`lastname`, c.`email`, adr.address1, adr.address2,
            adr.`postcode`, adr.`city`, ctrylang.`name` as mycountry, c.`birthday`, c.`newsletter`, c.`optin`
            FROM `' . _DB_PREFIX_ . 'customer` c 
            LEFT JOIN `' . _DB_PREFIX_ . 'address` adr ON ( c.`id_customer`= adr.`id_customer`)
            LEFT JOIN `' . _DB_PREFIX_ . 'customer_group` cg ON c.`id_customer`= cg.`id_customer`
            LEFT JOIN `' . _DB_PREFIX_ . 'country_lang` ctrylang ON ( ctrylang.`id_country`= adr.`id_country` AND ctrylang.`id_lang` = '.(int)$id_lang.')
            LEFT JOIN `' . _DB_PREFIX_ . 'gender_lang` cvl ON (cvl.`id_gender`= c.`id_gender` AND cvl.`id_lang` = '.(int)$id_lang.')
            WHERE c.`id_customer` IN ('.implode(',', $params).') AND c.`id_shop`='.(int)$this->context->shop->id; 
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($sql);
        foreach ($result as $value) {            
            $idcustomer = $value['id_customer'];                
            $out[$idcustomer]['group'] = $this->getGroupCustomer($idcustomer, $id_lang,true);
            $out[$idcustomer]['firstname'] = $value['firstname'];
            $out[$idcustomer]['lastname'] = $value['lastname'];
            $out[$idcustomer]['birthday'] = $value['birthday'];
            $out[$idcustomer]['newsletter'] = $value['newsletter'];
            $out[$idcustomer]['optin'] = $value['optin'];
            $out[$idcustomer]['civility'] = $value['civility'];
            $out[$idcustomer]['address1'][] = $value['address1'];
            $out[$idcustomer]['address2'][] = $value['address2'];
            $out[$idcustomer]['postcode'][] = $value['postcode'];
            $out[$idcustomer]['city'][] = $value['city'];
            $out[$idcustomer]['mycountry'][] = $value['mycountry'];
            $out[$idcustomer]['email'] = $value['email'];
            $out[$idcustomer]['order'] = $this->getInfosOrder($idcustomer);
        }
        
        // génération du CSV
        $fichier = '/files/segmentor-'.date('Y-m-d').'.csv';
        $f=fopen(dirname(__FILE__).$fichier, 'w+');       
        fputcsv($f, $fiels, ';', '"'); 
        foreach ($out as $customerline) {
            $fiels = array(
                'civility' => $this->cleanHtml($customerline['civility']),
                'firstname' => $this->cleanHtml($customerline['lastname']),
                'lastname' => $this->cleanHtml($customerline['firstname']),
                'address1' => $this->cleanHtml(implode('#', array_unique($customerline['address1']))),
                'address2' => $this->cleanHtml(implode('#', array_unique($customerline['address2']))),
                'postcode' => $this->cleanHtml(implode(',', array_unique($customerline['postcode']))),
                'city' => $this->cleanHtml(implode(',', array_unique($customerline['city']))),
                'mycountry' => $this->cleanHtml(implode(',', array_unique($customerline['mycountry']))),
                'email' => $this->cleanHtml($customerline['email']),
                'mygroup' => implode(',', $customerline['group']),
                'birthday' => $this->cleanHtml($customerline['birthday']),
                'newsletter' => $customerline['newsletter'],
                'optin' => $customerline['optin'],
                'quantity_order' => $customerline['order']['qty_order'],
                'total_order' => $customerline['order']['total_order'],
            );
            fputcsv($f, $fiels, ';', '"'); 
        }
        fclose($f);
        
        $Shop = new Shop($this->context->shop->id);
        return $this->displayConfirmation($this->l('CSV file has been generate succefull').' : <a href="'.$Shop->getBaseURL().'modules/'.$this->name.$fichier.'" target="_blank" >'.$this->l('click here to download CSV file').'</a>');
    }
    /**
     * get total order and quantity order
     * @param type $idcustomer
     * @return type
     */
    private function getInfosOrder($idcustomer){
        $out = array('total_order'=>'','qty_order'=>0);
        $sql = 'SELECT SUM(o.total_paid) AS total_order, 
            COUNT(*) AS qty_order FROM `' . _DB_PREFIX_ . 'orders` AS o 
            WHERE o.id_customer='.(int)$idcustomer.' AND o.id_shop='.(int)$this->context->shop->id;
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($sql);
        foreach ($result as $value) {
            $out['total_order'] = $value['total_order'];
            $out['qty_order'] = $value['qty_order'];
        }
        return $out;
    }
    /**
     * Supprime toute balise html et les saut de ligne dune chaine 
     * @param type $stringV
     * @return type
     */
	private function cleanHtml($stringV){
		//$string = Tools::safeOutput($string);
        $stringV = Tools::iconv("UTF-8","ISO-8859-1",$stringV);
		$stringV = strip_tags($stringV); // get rid of illegal SGML chars        
		$stringV = str_replace("\r\n", " ", $stringV); // get rid of illegal SGML chars
        $stringV = str_replace("&nbsp;", " ", $stringV);
        $stringV = str_replace("&#39;", "' ", $stringV);
        $stringV = str_replace("&#150;", "-", $stringV);
        $stringV = str_replace(chr(9), " ", $stringV);
        $stringV = str_replace(chr(10), " ", $stringV);
        $stringV = str_replace(chr(13), " ", $stringV);
		$stringV = str_replace("|", " ", $stringV); // get rid of illegal SGML chars
		return $stringV;
	}
    
     /**
     * Ajoute un client à un groupe
     * @return type
     */
    public function addCustumersgroup(){
        $params = Tools::getValue('cbidcustomer');
        if($params){
            foreach ($params as $value)
            {
                $res = Db::getInstance()->getRow('SELECT `id_customer` FROM `'._DB_PREFIX_.'customer_group` WHERE `id_customer`="'.pSQL($value).'" AND `id_group`="'.pSQL(Tools::getValue('transfertGroup')).'"');
                if(empty($res)){
                    $row = array('id_customer' => (int)$value, 'id_group' => (int)Tools::getValue('transfertGroup'));
                    Db::getInstance()->insert('customer_group', $row);
                }
            } 
        }
    }
    
     /**
     * Supprime un client à un groupe
     * @return type
     */
    public function DeleteCustumersgroup(){
        $params = Tools::getValue('cbidcustomer');
        if(!$params)
            return '<div class="conf error"><img src="../img/admin/error.png" alt="' . $this->l('Error') . '" />' . $this->l('Please select minimun customer') . '</div>';
        $out = array();
        
        if(count($params)){
            $sql = 'DELETE FROM '._DB_PREFIX_.'customer_group  WHERE  id_customer IN ('.implode(',', $params).') AND id_group='.Tools::getValue('transfertGroup');
            Db::getInstance()->execute($sql);
        }
    }
}

?>
